diff --git a/treebrowser/src/treebrowser.c b/treebrowser/src/treebrowser.c
index ab435fe..666bb0e 100644
--- a/treebrowser/src/treebrowser.c
+++ b/treebrowser/src/treebrowser.c
@@ -439,12 +439,14 @@ static void
 treebrowser_chroot(gchar *directory)
 {
 	if (g_str_has_suffix(directory, G_DIR_SEPARATOR_S))
-		g_strlcpy(directory, directory, strlen(directory));
+		directory = g_strndup(directory, strlen(directory)-1);
+	else
+		directory = g_strdup(directory);
 
 	gtk_entry_set_text(GTK_ENTRY(addressbar), directory);
 
 	if (!directory || strlen(directory) == 0)
-		directory = g_strdup(G_DIR_SEPARATOR_S);
+		setptr(directory, g_strdup(G_DIR_SEPARATOR_S));
 
 	if (! treebrowser_checkdir(directory))
 	{
